#!/usr/bin/env python
"""
Copyright 2015 Reverb Technologies, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

class V1beta3_NodeSystemInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually."""


    def __init__(self):
        """
        Attributes:
          swaggerTypes (dict): The key is attribute name and the value is attribute type.
          attributeMap (dict): The key is attribute name and the value is json key in definition.
        """
        self.swaggerTypes = {
            
            'KubeProxyVersion': 'str',
            
            
            'bootID': 'str',
            
            
            'containerRuntimeVersion': 'str',
            
            
            'kernelVersion': 'str',
            
            
            'kubeletVersion': 'str',
            
            
            'machineID': 'str',
            
            
            'osImage': 'str',
            
            
            'systemUUID': 'str'
            
        }

        self.attributeMap = {
            
            'KubeProxyVersion': 'KubeProxyVersion',
            
            'bootID': 'bootID',
            
            'containerRuntimeVersion': 'containerRuntimeVersion',
            
            'kernelVersion': 'kernelVersion',
            
            'kubeletVersion': 'kubeletVersion',
            
            'machineID': 'machineID',
            
            'osImage': 'osImage',
            
            'systemUUID': 'systemUUID'
            
        }       

        
        #Kube-proxy version reported by the node
        
        self.KubeProxyVersion = None # str
        
        #boot id is the boot-id reported by the node
        
        self.bootID = None # str
        
        #Container runtime version reported by the node through runtime remote API (e.g. docker://1.5.0)
        
        self.containerRuntimeVersion = None # str
        
        #Kernel version reported by the node from &#39;uname -r&#39; (e.g. 3.16.0-0.bpo.4-amd64)
        
        self.kernelVersion = None # str
        
        #Kubelet version reported by the node
        
        self.kubeletVersion = None # str
        
        
        self.machineID = None # str
        
        #OS image used reported by the node from /etc/os-release (e.g. Debian GNU/Linux 7 (wheezy))
        
        self.osImage = None # str
        
        
        self.systemUUID = None # str
        
