#!/usr/bin/env python
"""
Copyright 2015 Reverb Technologies, Inc.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

class V1beta3_PodSpec(object):
    """NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually."""


    def __init__(self):
        """
        Attributes:
          swaggerTypes (dict): The key is attribute name and the value is attribute type.
          attributeMap (dict): The key is attribute name and the value is json key in definition.
        """
        self.swaggerTypes = {
            
            'containers': 'list[V1beta3_Container]',
            
            
            'dnsPolicy': 'str',
            
            
            'host': 'str',
            
            
            'hostNetwork': 'bool',
            
            
            'nodeSelector': 'dict',
            
            
            'restartPolicy': 'str',
            
            
            'volumes': 'list[V1beta3_Volume]',

            'metadata': 'dict'
        }

        self.attributeMap = {
            
            'containers': 'containers',
            
            'dnsPolicy': 'dnsPolicy',
            
            'host': 'host',
            
            'hostNetwork': 'hostNetwork',
            
            'nodeSelector': 'nodeSelector',
            
            'restartPolicy': 'restartPolicy',
            
            'volumes': 'volumes',

            'metadata': 'metadata'
            
        }       

        
        #list of containers belonging to the pod; cannot be updated; containers cannot currently be added or removed; there must be at least one container in a Pod
        
        self.containers = None # list[V1beta3_Container]
        
        #DNS policy for containers within the pod; one of &#39;ClusterFirst&#39; or &#39;Default&#39;
        
        self.dnsPolicy = None # str
        
        #host requested for this pod
        
        self.host = None # str
        
        #host networking requested for this pod
        
        self.hostNetwork = None # bool
        
        #selector which must match a node&#39;s labels for the pod to be scheduled on that node
        
        self.nodeSelector = None # any
        
        #restart policy for all containers within the pod; one of RestartPolicyAlways, RestartPolicyOnFailure, RestartPolicyNever
        
        self.restartPolicy = None # str
        
        #list of volumes that can be mounted by containers belonging to the pod
        
        self.volumes = None # list[V1beta3_Volume]

        self.metadata = None # dict
