# coding: utf-8

"""
Copyright 2015 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems


class V1AWSElasticBlockStoreVolumeSource(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Swagger model

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'volume_id': 'str',
            'fs_type': 'str',
            'partition': 'int',
            'read_only': 'bool'
        }

        self.attribute_map = {
            'volume_id': 'volumeID',
            'fs_type': 'fsType',
            'partition': 'partition',
            'read_only': 'readOnly'
        }

        self._volume_id = None
        self._fs_type = None
        self._partition = None
        self._read_only = None

    @property
    def volume_id(self):
        """
        Gets the volume_id of this V1AWSElasticBlockStoreVolumeSource.
        unique id of the PD resource in AWS; see http://releases.k8s.io/v1.0.4/docs/volumes.md#awselasticblockstore

        :return: The volume_id of this V1AWSElasticBlockStoreVolumeSource.
        :rtype: str
        """
        return self._volume_id

    @volume_id.setter
    def volume_id(self, volume_id):
        """
        Sets the volume_id of this V1AWSElasticBlockStoreVolumeSource.
        unique id of the PD resource in AWS; see http://releases.k8s.io/v1.0.4/docs/volumes.md#awselasticblockstore

        :param volume_id: The volume_id of this V1AWSElasticBlockStoreVolumeSource.
        :type: str
        """
        self._volume_id = volume_id

    @property
    def fs_type(self):
        """
        Gets the fs_type of this V1AWSElasticBlockStoreVolumeSource.
        file system type to mount, such as ext4, xfs, ntfs; see http://releases.k8s.io/v1.0.4/docs/volumes.md#awselasticblockstore

        :return: The fs_type of this V1AWSElasticBlockStoreVolumeSource.
        :rtype: str
        """
        return self._fs_type

    @fs_type.setter
    def fs_type(self, fs_type):
        """
        Sets the fs_type of this V1AWSElasticBlockStoreVolumeSource.
        file system type to mount, such as ext4, xfs, ntfs; see http://releases.k8s.io/v1.0.4/docs/volumes.md#awselasticblockstore

        :param fs_type: The fs_type of this V1AWSElasticBlockStoreVolumeSource.
        :type: str
        """
        self._fs_type = fs_type

    @property
    def partition(self):
        """
        Gets the partition of this V1AWSElasticBlockStoreVolumeSource.
        partition on the disk to mount (e.g., '1' for /dev/sda1); if omitted the plain device name (e.g., /dev/sda) will be mounted; see http://releases.k8s.io/v1.0.4/docs/volumes.md#awselasticblockstore

        :return: The partition of this V1AWSElasticBlockStoreVolumeSource.
        :rtype: int
        """
        return self._partition

    @partition.setter
    def partition(self, partition):
        """
        Sets the partition of this V1AWSElasticBlockStoreVolumeSource.
        partition on the disk to mount (e.g., '1' for /dev/sda1); if omitted the plain device name (e.g., /dev/sda) will be mounted; see http://releases.k8s.io/v1.0.4/docs/volumes.md#awselasticblockstore

        :param partition: The partition of this V1AWSElasticBlockStoreVolumeSource.
        :type: int
        """
        self._partition = partition

    @property
    def read_only(self):
        """
        Gets the read_only of this V1AWSElasticBlockStoreVolumeSource.
        read-only if true, read-write otherwise (false or unspecified); see http://releases.k8s.io/v1.0.4/docs/volumes.md#awselasticblockstore

        :return: The read_only of this V1AWSElasticBlockStoreVolumeSource.
        :rtype: bool
        """
        return self._read_only

    @read_only.setter
    def read_only(self, read_only):
        """
        Sets the read_only of this V1AWSElasticBlockStoreVolumeSource.
        read-only if true, read-write otherwise (false or unspecified); see http://releases.k8s.io/v1.0.4/docs/volumes.md#awselasticblockstore

        :param read_only: The read_only of this V1AWSElasticBlockStoreVolumeSource.
        :type: bool
        """
        self._read_only = read_only

    def to_dict(self):
        """
        Return model properties dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Return model properties str
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()
